DEFine PROCedure compare_dir(s_dir$,d_dir$,drilldown%,deepscan%,exclude$,repchan%,filedir$)
REMark compares files on dev1 to those on dev2
REMark this does not check that a file on dev2 exists where no such file exists on dev1
rem params:
rem   drilldown% : if <> 0, drill down into subdirs
rem   deepscan% : if <> not onlyncheck file date,length and type but compare content if type, date and length are he same
rem   exclude$ an array with file exte0snions to exclude : any files with these extensions will not be compared
rem   filedir$ device for temp files
rem uses the global vars result$ which contains the resulting files and allcount% which contains the numbr of elements used in the result$ array
rem
rem !!!! the tempchan% var is from caller!!!
rem the caller must have checked that the two dirs are on a valid device (i.e. name length >5)
rem
LOCal lp%,chan%,l,a$,dnm$,result,maxcnt,exc% ,dirfile$,ot%,flength,fdateb,nmlen%
local fnames$(1,1),dsize%,dchan%,slen%,dlen%, devs$,devd$,sdnm$,ddnm$,b$
  if allcount%>32760 or allcount%<0 : return
  maxcnt=dimn(result$,1)
  exc%=dimn(exclude$,1)
  s_dir$=add_underscore$(s_dir$)
  d_dir$=add_underscore$(d_dir$) : rem make sure dirnames end in "_"
  slen%=len(s_dir$)
  dlen%=len(d_dir$)
  devs$=s_dir$(1 to 5)		: rem source device
  devd$=d_dir$(1 to 5)
  if slen%=5
    sdnm$=""
  else
    sdnm$=s_dir$(6 to)		: rem source dir w/o device
  end if
  if dlen%=5
    ddnm$=""
    if ftest(d_dir$)
	dr_unst warn_defn
	exc%=warning% (d_dir$&" can't be opened!",repchan%,"Device error")
	info "" ,repchan%
	return
    endif
  else
    ddnm$=d_dir$(6 to)		: rem dest dir w/o device
  end if
  rep lp%
    dirfile$=filedir$&ddnm$&rnd(1 to 1000)
    chan%=fop_over(dirfile$)
    if chan%>0:exit lp%
  end rep lp%
  cls#repchan%,3
  at#repchan%,2,0:print#repchan%,"Scanning : ";s_dir$
  if slen%<>5:add_dir d_dir$	: rem add this dir to the list of dirs
  dchan%=fop_dir(s_dir$)	: rem open source dir
  if dchan%<0:close#chan%:return
  dsize%=flen(#dchan%) / 64	: rem max files in this dir
  close#dchan%
  dim fnames$(dsize%+1,string_length%)
  DIR#chan%,s_dir$		: rem get the dir content
  print #chan%
  get#chan%\0
  INPUT#chan%, a$
  INPUT#chan%, a$
  dsize%=0
  rep lp%
    if eof (#chan%):exit lp%
    dsize%=dsize%+1
    input#chan%,fnames$(dsize%) : rem get all files into an array...
  end rep lp%
  close#chan%
  delete dirfile$
  if dsize%>20
    qsortf fnames$,0,0		: rem sort the array
  else
    insort fnames$,0
  endif
  for lp%= 1 to dsize%
    if allcount%>32760
	dr_unst warn_defn
	exc%=warning% ( "OK =show just those elements"&chr$(10)&"ESC = quit program entirely",repchan%,"I can't handle more than 32760 elements!")
	if exc%=0:allcount%=-1
	info "" ,repchan%
	return
    endif
    a$=strip_spaces$(fnames$(lp%)) : rem use strip_spaces because of Qlib array handling
    if a$="":next lp%:exit lp%
    l= " ->" INSTR a$
    IF l>0
      IF (l+2=LEN(a$))
	if not drilldown%:next lp%:exit lp%
	a$=a$(1 TO l-1)
	if a$==sdnm$:next lp%:exit lp% : rem skip too long filenames, and stop calling the same dir over & over again
	if sdnm$<>""
	  b$=a$(len(sdnm$)+1 to)	: rem name of file in subdir
	else
	  b$=a$
	endif
	compare_dir devs$&a$,devd$&ddnm$&b$,drilldown%,deepscan%,exclude$,repchan%,filedir$
	if allcount%>32760 or allcount%<0:return
	NEXT lp%:exit lp%
      END IF
    END IF
    if exc%
       IF endswith% (exclude$,a$):NEXT lp% :exit lp%
    endif
    if sdnm$<>""
       b$=a$(len(sdnm$)+1 to)	     : rem name of file in subdir
    else
       b$=a$
    endif
    nmlen%=len(devd$&ddnm$&b$)	: rem length of name on destination
    if nmlen%>max_filenamelength%
	nmlen%=-1
	result=-1
    else
	result=fcompa(devs$&a$,devd$&ddnm$&b$,deepscan%)
    endif
    if result<>0
      if (result > 0 and (result && 1))
	 if options%(5)=0
	   dr_unst warn_defn
	   result=warning%("Can't open source file "&devs$&a$,0,"Error") : rem can't open input file
	   info "Scanning :"&s_dir$,repchan%
	 endif
	 next lp%:exit lp%
      endif
      ot%=fop_in(devs$&a$)	: rem open source file
      if ot% > 0
	fdateb=fupdt(#ot%)
	flength=flen(#ot%)	: rem get length and date
	close#ot%
      else
	flength=0:fdateb=0	: rem huh?
      endif
      if result=-1
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"g"	    : rem destfile name is too long
	 impcount=impcount+1
	 next lp%:exit lp%
      endif
      if (result &&  2)
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"a"	    : rem file doesn't exist on drive 2
	 necount=necount+1
      endif
      if (result && 64) and (options%(0)<2 )
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"d"	   : rem source file is older than dest file
	 ddcount=ddcount+1
	 if options%(1)>2:next lp%:exit lp%
      endif
      if result && 128
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"e"	    : rem dest file is older than source file
	 ddcount=ddcount+1
	 if options%(1)>2:next lp%:exit lp%
      endif
      if result && 16
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"b"	    : rem files of different type
	 tdcount=tdcount+1
      endif
      if result && 32
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"c"	    : rem files of different length
	 dlcount=dlcount+1
      endif
      if result && 256
	 allcount%=allcount%+1
	 print#tempchan%,format_string$&"f"	    : rem file date,type & size are equel but not content
	 difcount=difcount+1
      endif
    endif
  end for lp%
 rem dim fnames$(1,1)
END DEFine compare_dir
:
def fn add_underscore$ (nm$)
rem checks that name has an underscore at end, if not adds it
  local t%
  t%=len(nm$)
  if t%=0:return "_"			: rem huh????
  if nm$(t%)="_"
    return nm$
  else
    return nm$&"_"
  endif
end def add_underscore$
:
