def proc get_old_statusses
rem get statusses from menu_mfl% into correct status array
  select on current_choice%
    =0:arrcopy main_mfl%,tot_objs%
    =1:arrcopy main_mfl%,non_ext%
    =2:arrcopy main_mfl%,type_d%
    =3:arrcopy main_mfl%,length_d%
    =4:arrcopy main_mfl%,date_d%
    =5:arrcopy main_mfl%,cont_d%
    =6:arrcopy main_mfl%,imp_d%
  end select
end def get_old_statusses
:
def proc get_new_statusses
rem get statusses from	correct status array into main_mfl%
  select on current_choice%
    =0:arrcopy tot_objs%,main_mfl%
    =1:arrcopy non_ext%,main_mfl%
    =2:arrcopy type_d%,main_mfl%
    =3:arrcopy length_d%,main_mfl%
    =4:arrcopy date_d%,main_mfl%
    =5:arrcopy cont_d%,main_mfl%
    =6:arrcopy imp_d%,main_mfl%
  end select
end def get_new_statusses
:
def proc change_all_statusses (status%)
rem change the statusses of all items in all tabs
  if not (status% && 1):status%=status%+1
  change_statusses tot_objs%,status%
  change_statusses non_ext%,status%
  change_statusses type_d%,status%
  change_statusses length_d%,status%
  change_statusses date_d%,status%
  change_statusses cont_d%,status%
  change_statusses imp_d%,status%
end def change_all_statusses
:
def proc change_statusses (status_array%,status%)
local lp%,count%
  for lp%=0 to dimn(status_array%,1)
       status_array%(lp%,0)=status%
  end for lp%
end def change_statusses
:
def proc change_status_of_one_item_in_all_tabs (a$,status%)
rem changes the status of one item only, in all tabs
local found%
  found%=asearch2(result$,a$,0,0)
  if found%>-1
    tot_objs%(found%-1,0)=status%
  endif
  found%=asearch2(nonexistent$,a$,0,0)
  if found%>-1
    non_ext%(found%-1,0)=status%
  endif
  found%=asearch2(typediff$,a$,0,0)
  if found%>-1
    type_d%(found%-1,0)=status%
  endif
  found%=asearch2(lengthdiff$,a$,0,0)
  if found%>-1
    length_d%(found%-1,0)=status%
  endif
  found%=asearch2(diffdate$,a$,0,0)
  if found%>-1
    date_d%(found%-1,0)=status%
  endif
  found%=asearch2(contdiff$,a$,0,0)
  if found%>-1
    cont_d%(found%-1,0)=status%
  endif
  found%=asearch2(impossible$,a$,0,0)
  if found%>-1
    imp_d%(found%-1,0)=status%
  endif
end def change_status_of_one_item_in_all_tabs
:
def proc change_status_in_current_tab (a$,status%)
rem changes the status only in the flag array coreespondin to the current tab
rem this is NOT cpied back into main_mfl% here!
  if not (status% &&1):status%=status%+1
  select on current_choice%
    =0: change_item_status result$,a$,status%,tot_objs%
    =1: change_item_status nonexistent$,a$,status%,non_ext%
    =2: change_item_status typediff$,a$,status%,type_d%
    =3: change_item_status lengthdiff$,a$,status%,length_d%
    =4: change_item_status diffdate$,a$,status%,date_d%
    =5: change_item_status contdiff$,a$,status%,cont_d%
    =6: change_item_status impossible$,a$,status%,imp_d%
  end select
end def change_status_in_current_tab
:
def proc change_item_status (strings$,to_change$,new_status%,flags%)
rem change status of one item (to_change$)in the flag% array to the new_status%
rem this is NOT cpied back into main_mfl% here!
local found%
  found%=asearch2(strings$,to_change$,0,0)
  if found% > -1
    flags%(found%-1,0)=new_status%
  endif
end def change_item_status
:
