def fn format_string$
rem this formats a string used as object for the main appsub menu window
rem !!!
rem dev1$,dev2$,a$,flength,fdateb are from compare_dir
rem !!!
local temp$,fi$,len$
  temp$=size_string$(a$,name_length%,0)&"  " : rem name + separator
  temp$=temp$&make_date$(2,fdateb)&"  " : rem date & time
  return temp$&size_string$(long$(flength),size_length%,1)&"0"
end def format_string$
:
DEFine FuNction make_date$(dflag%,what_date)
rem returns date as "01.01.1991" (dflag%=1) or "1991.01.31" (dflag%=0)
rem or as "01.01.1991 10:30" (dflag%=3) or as "1991.01.01 10:30" (dflag%=2)
rem if what_date<>0, then it is this date that will be returned
rem !!!!!
rem this presumes that a variable "all_months$" exists!
rem !!!!!
  LOCal a$,b$,res
  b$=""
  IF what_date
    a$=DATE$(what_date) 		: rem make date passed as param into string
  ELSE
    a$=DATE$				: rem current date into string
  END IF
  b$=a$(6 TO 8) 			: rem 3 letter month abbreviation
  res= b$ INSTR all_months$		: rem find it
  IF NOT res
       all_months$=make_all_months$	: rem not found?, make all_month$
       res= b$ INSTR all_months$	: rem and retry
  END IF
  res=(res+2)/3 			: rem this is the month in figures
  b$=res:IF res<10:b$="0"&b$		: rem add leading 0 if necessary
  select on dflag%
    = 0: return a$(1 TO 4)&"."&b$&"."&a$(10 TO 11)
    = 1: return a$(10 TO 11)&"."&b$&"."&a$(1 TO 4)
    = 2: return a$(1 TO 4)&"."&b$&"."&a$(10 TO 11)&" "&a$(13 to 17)
    = remainder: return a$(10 TO 11)&"."&b$&"."&a$(1 TO 4)&" "&a$(13 to 17)
  end select
END DEFine make_date$
:
def fn size_string$(string$,size%,leftfill%)
rem makes a string a size% length, left filled (leftfilled%=1) or padded
rem with spaces if need be, or cut off after size% chars
local sz%
  sz%=len(string$)
  if sz%>size% : return string$(1 to sz%)
  if sz%<size%
    if leftfill%
      return fill$(" ",size%-sz%)&string$
    else
      return string$&fill$(" ",size%-sz%)
    endif
  endif
  return string$			: rem string was of exact size
end def size_string$
:
