def proc make_main_window (xptr%,yptr%)
rem this initialises the following global variables:
rem all the windows (_defn,_lfl%,_cty%,mfl% etc...)
rem all the sprites
rem v. 1.04
local nbr_post%,temp4%
local main_iot1,main_iot2,main_iwt,main_lot
local longueur_titre%,titre_x%,s$,d$,tab_appwin_ypos%,tab_appwin_ysize%
local sort_appwinysize%,sort_appwin_ypos%,max_rows%
rem do not make main_lit%,lxs% local, they are needed in change_size
:
  rem types of objects
  text=0:sprite=2:blob=4:pattern=6
  retr=256:retn=-256:sous1=254:sous2=252
:
: rem standard event codes
  hit$=CHR$(1):do$=CHR$(2):cancel$=CHR$(3):sleep$=CHR$(7):wake$=CHR$(8)
  help$=CHR$(4):move$=CHR$(5):size$=CHR$(6):cr$=CHR$(10)
:
  lxs%=24:lys%=12		: rem x,y sizes for standard small loose items
  inf1y%=lys%+4 		: rem y pos of inner window
  xesp%=lxs%+2			: rem spacing for standard small loose items
  nbr_post%=5			: rem how many loose items in each corner
:
  rem now make y size of window. this depends on the sizes of the inner wdws
  rowsize%=12			: rem y size of one row in menu appsub wdw
  tab_appwin_ysize%=24
  tab_appwin_ypos%=inf1y%
  sort_appwin_ysize%=12
  sort_appwin_ypos%=tab_appwin_ypos%+tab_appwin_ysize%
  main_appwin_offset%=sort_appwin_ypos%+sort_appwin_ysize% : rem y offset for appsub win
  ysize%=ysize%-main_appwin_offset%-14
  nr_rows%=ysize% DIV rowsize%	       : rem GLOBAL var: nbr of rows in appsub
  max_rows%=(scr_ylim-main_appwin_offset%-20) div rowsize%
  IF nr_rows%>max_rows%:nr_rows%=max_rows%
  IF nr_rows%<3:nr_rows%=3
  ysize%=nr_rows%*rowsize%+main_appwin_offset%+12+2 : rem plus space for arrows
:
  make_standard_sprites 	: rem leave this before the restore
:
  RESTORE
:
  DIM std_iattr(3,3)		: rem standard loose item attributes
  RD_IATT std_iattr
    DATA 1,sp.litemhigh : rem size & colour current item border
    DATA sp.litemunabg,sp.litemunafg,0,0 : rem unavailable item paper & ink
    DATA sp.litemavabg,sp.litemavafg,0,0 : rem available
    DATA sp.litemselbg,sp.litemselfg,0,0 : rem selected
:
  titre$="Drive Backup"
:
  longueur_titre%=LEN(titre$)*6 : rem title size in pixels
  titre_x%=(xsize%-longueur_titre%)/2 : rem x position of title
  if source$<>"":s$="S "&source$:else s$="Source":endif
  if dest$<>"":d$="D "&dest$:else d$="Dest":endif
:
: rem  Loose menu items
  yinf1y%=inf1y%+4
  esc_it%=0		: rem this is a null sized item - will be invisible
  move_it%=esc_it%+1
  size_it%=move_it%+1
  sleep_it%=size_it%+1
  go_it%=sleep_it%+1
  source_it%=go_it%+1
  dest_it%=source_it%+1
  f3_it%=dest_it%+1
  all_it%=f3_it%+1
  about_it%=all_it%+1
:
  main_lit%=9:DIM main_lfl%(main_lit%)
  main_lot=RD_LOT(std_iattr,main_lit%)
    DATA 0,0,4+xesp%*0,2,0,0,cancel$,text+retr,''	: rem invisible ESC item
    DATA lxs%,lys%,4+xesp%*0,2,0,0,move$,sprite+retr,move_sprite
    DATA lxs%,lys%,4+xesp%*1,2,0,0,size$,sprite+retr,size_sprite
    DATA lxs%,lys%,xsize%-2-xesp%*1,2,0,0,sleep$,sprite+retr,sleep_sprite
    DATA lxs%,lys%,xsize%-2-xesp%*2,2,0,0,"G",sous1+retr,"Go"
    DATA lxs%*2,lys%,4+xesp%*2,2,0,0,"S",sous1+retr,s$
    DATA lxs%*2,lys%,xsize%-2-xesp%*4,2,0,0,"D",sous1+retr,d$
    DATA lxs%,lys%,4+xesp%*4,2,0,0,chr$(240),sprite+retr,14
    DATA lxs%,lys%,xsize%-2-xesp%*5,2,0,0,"A",sous1+retn,"All"
    DATA longueur_titre%,lys%-2,titre_x%,3,0,0,'B',256-14+retr,titre$
:
rem now the info object (string in title bar)
:
  main_iot1=RD_IOT(0)
    DATA longueur_titre%,10,4,INT((lys%-10)/2),text,sp.titlefg,0,0,titre$
:
rem now the info wdws - there are 3
:
  main_iwt=RD_IWT(2)
:
rem first the title bar
:
    DATA xsize%-8-(2*nbr_post%*xesp%),lys%+3,xesp%*nbr_post%+4,0	 : rem x,y sizes & origs
    DATA 0,0,sp.infwinbd,sp.titlebg	: rem shadow, border size & col,paper col
    DATA 0				: rem object pointer (none)
:
rem second wdw containing title itself
:
    DATA longueur_titre%+8,lys%+1,titre_x%-4,2
    DATA 0,0,sp.infwindbd,sp.infwinbg
    data 0
rem    DATA main_iot1			   : rem one object
:
rem third the inner border
:
    DATA xsize%-8,ysize%-inf1y%-2,4,inf1y%
    DATA 0,1,sp.infwinbd,sp.infwinbg
    DATA 0
:
rem now the application sub windows
:
rem item attributes are made by keyword automatically
:
  rem there are three appsub wdw
  dim appsubs(2)
:
rem first the menu appsub wdw with the filenames
:
  app_addr=0				: rem there is none yet
  mk_main_app result$			: rem make menu appsub wdw, put in appsubs(0)
:
rem second the	appsub wdw containing the tabs
  appsubs(1)=RD_APPW
    DATA xsize%-8,tab_appwin_ysize%,4,tab_appwin_ypos%
    DATA 0,1,sp.infwinbd,sp.infwinbg
    data 0,""
:
rem third the small appsub wdw containing the sort headers
  appsubs(2)=RD_APPW
    DATA xsize%-8,sort_appwin_ysize%,4,sort_appwin_ypos%
    DATA 0,1,sp.infwinbd,sp.infwinbg
    data 0,""
:
rem  if main_app_list<>0:rechp main_app_list
  main_app_list=mk_awl(appsubs)
:
rem  now the window defn itself
  if xptr%<0 and yptr%<0
     xptr%=xsize% / 2			: rem if no ptr pos given, center ppointer
     yptr%= ysize% /2
   endif
   if xptr%<0:xptr%=0
   if yptr%<0:yptr%=0
   if xptr%>xsize%:xptr%=ysize%
   if yptr%>ysize%:yptr%=ysize%
:
  restore
  main_defn=RD_WDEF
    DATA 2,1,sp.winbd,sp.winbg: rem shadow, border sie & colour, paper colour
    DATA xsize%,ysize%,xptr%,yptr% : rem x,y sizes and ptr pos
    DATA main_sprite,main_lot,main_iwt,main_app_list
:
END DEFine make_main_window
:
